#include "mbed.h"
#include "mbed_rpc.h"
#include "RPCType.h"

RPCType::RPCType(): supported_types(){}

RPCType& RPCType::instance()
{
    static RPCType t;
    return t;
}

void RPCType::register_types()
{
    RPCType &t = instance();
    RPC::add_rpc_class<RpcAlarm>();
    t.supported_types.push_back("Alarm");
    RPC::add_rpc_class<RpcDigitalOut>();
    t.supported_types.push_back("DigitalOut");
}

bool RPCType::is_supported_type(char *type)
{
    for(std::list<char*>::iterator itor = instance().supported_types.begin();
        itor != instance().supported_types.end();
        ++itor)
        if(!strcmp(*itor,type))
            return true;

    return false;
}


